﻿@{ 
    Layout = null;
}
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>@ViewBag.Title   </title>

    @Scripts.Render("~/bundles/modernizr")
    <link rel="stylesheet" href="~/Content/vendors/mdi/css/materialdesignicons.min.css">
    <link rel="stylesheet" href="~/Content/vendors/base/vendor.bundle.base.css">
    <link rel="stylesheet" href="~/Content/css/style.css">
    <link rel="shortcut icon" href="images/favicon.png" />
    <link rel="stylesheet" href="~/Content/css/jquery-ui.min.css">
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/jqueryval")
    <link rel="stylesheet" href="~/Content/Site.css">
    <link rel="stylesheet" href="~/Content/css/toastr.css">

</head>


<body>
    <div class="container-scroller">
        <div class="loader"></div>
        @Html.Partial("_HeaderView")
        <div class="container-fluid page-body-wrapper">
            <nav class="sidebar sidebar-offcanvas" id="sidebar">
                <ul class="nav">

                    <li class="nav-item">

                        <div class="" id="ui-basic">
                            <ul class="nav flex-column sub-menu" id="list-menu">
                            </ul>
                        </div>
                    </li>

                </ul>
            </nav>
            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                        <div class="col-md-12 grid-margin">
                            <div class="card bg-gradient-primary border-0">
                                <div class="card-body py-3 px-4 d-flex align-items-center justify-content-between flex-wrap">
                                    <p class="mb-0 text-white font-weight-medium"> Kindly select and fill-in the correct answer for the question below</p>
                                    <div class="d-flex">
                                       @*<a href="~/Content/ExcelTemplate/CHAMPIONSEXCEL.xlsx" target="_blank" class="btn btn-outline-light mr-2">Download</a>*@
                                        <button id="bannerClose" class="btn border-0 p-0">
                                            <i class="mdi mdi-close text-white"></i>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">

                        <div class="col-sm-12">
                            <div class="card" id="session">
                                <h2 class="card-header text-center">Section (<span id="questionCategory"></span>) </h2>

                                <div class="row">
                                    <div class="col-md-6 ">
                                        <div class="form-group m-4">
                                           
                                        </div>
                                       
                                    </div>
                                    <div class="col-md-4 ">
                                       
                                    </div>
                                </div>


                                <div class="card-body">
                                    <h5 class="card-title"></h5>
                                    <form id="form-questn">
                                    </form>
                                </div>
                                <div class="card-footer float-btn">
                                    @*<a href="#" class="btn btn-danger">Save Session</a> &nbsp; &nbsp;*@
                                    <span class="" id="btnSave">  </span>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>
                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted text-center text-sm-left d-block d-sm-inline-block">Copyright © 2020 <a href="https://www.ubagroup.com/" target="_blank">UBA Group</a>. All rights reserved.</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    <script type="text/javascript">
    var allQuestions = [];
        var counter = 0;
        var sessionTotal = 0;
      

     var optionListUrl = '@Url.Action("GetAllQuestionsAsync", "AssessmentPortal")';
        questionArray();
        // Display all question
    function questionArray() {
        $.ajax({
            type: 'GET',
            url: optionListUrl,
           // data: "",
            dataType: 'json',
            success: function (data) {
                allQuestions = data.data;
                $.each(allQuestions, function (i, value) {
                    $("#list-menu").append($('<li class="nav-item">  <a class="nav-link" href="#" onclick=moveCategory(' + i + ') id="check' + i + '" > ' + value.CategoryName + '</a></li>'));

                });
                   displayCategoryQuestions(counter)
            }
        });
        }

        function displayCategoryQuestions(value) {
            counter = value;
          
            $("#questionCategory").html(allQuestions[counter].CategoryName);
            
            $("[id*='check']").removeClass("active");
            $("#check" + counter).addClass('active');
            $("#btnSave").empty();
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;
            console.log("value", counter);
            console.log("Length", allQuestions.length);
            if(counter>0)
             $("#btnSave").append($('<button type="button" onclick="previousBtn('+value+')" class="btn btn-light mr-4"> Previous  </button>'));
            $("#btnSave").append($('<button type="submit" onclick="submitForm()" class="btn btn-danger mr-2">' + (presentValue<arrayLength?'Next & Save':'Submit') + '</button>'));
            $("#form-questn").empty();

            $.each(allQuestions[value].TestQuestion, function (i, value) {
                if (value.QuestionType === 2)
                    $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> (' + (i + 1) + ')  ' + value.QuestionText + ' </h4><div class="option" > <label><input type="radio" id="opt' + (value.QuestionId) + 'v' + 1 + '" name="' + value.QuestionId + '" value="1" class="choice" required /> Yes</label> <br /> <label><input type="radio" required id="opt' + (value.QuestionId) + 'v' + 2 + '"   name="' + value.QuestionId + '" value="2" class="choice" /> No</label> <br />  </div> </div>'));
                else if (value.QuestionType === 1)
                    $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> (' + (i + 1) + ')  ' + value.QuestionText + ' </h4><div class="option" > <label><input type="radio" id="opt' + (value.QuestionId) + 'v' + 1 + '" name="' + value.QuestionId + '" value="1" class="choice" required /> ' + value.AnswerTextA + '</label> <br /> <label><input type="radio" required id="opt' + (value.QuestionId) + 'v' + 2 + '"   name="' + value.QuestionId + '" value="2" class="choice" /> ' + value.AnswerTextB + '</label> <br /> <label><input type="radio" id="opt' + (value.QuestionId) + 'v' + 3 + '"   name="' + value.QuestionId + '" value="3" class="choice" /> ' + value.AnswerTextC + '</label>  <br /> <label><input type="radio" id="opt' + (value.QuestionId) + 'v' + 4 + '"   name="' + value.QuestionId + '" value="4" class="choice" /> ' + value.AnswerTextD + '</label>  </div> </div>'));
                else if (value.QuestionType === 0)
                    $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> (' + (i + 1) + ')  ' + value.QuestionText + ' </h4><div class="option" > <label class="row"><input type="number" id="opt' + (value.QuestionId) + 'v' + 1 + '" name="' + value.QuestionId + '" class="form-control col-md-6" required placeholder="Supply numeric value here" value="0"/>   </div> </div>'));

            })
            //Testing checked answer.
            SavedAnswers(allQuestions[value].QuestionCategoryId);
           // $("#opt1034v1").attr('checked', true);
        }
        

        function SavedAnswers(QuestionCatId) {
            var urlSavedAns='@Url.Action("GetAllResult")'
               $.ajax({
            url: urlSavedAns,
            type: 'GET',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: 'QuestionCatId='+QuestionCatId+'',
                   success: function (response) {
                       if (response.data) {
                           $.each(response.data.answers, function (key, value) {
                               console.log('Value' + value)
                               if (value.QuestionType === 0) {
                                       $('#opt' + value.QuestionId + 'v1'  + '').val(value.AnswerValue);
                               }
                               else
                               $('#opt' + value.QuestionId + 'v' + value.answerEnum + '').attr('checked', true);
                           });

                           
                       }
                   }
        });
        }

        function previousBtn(value) {
            
            console.log("value::: " + value)
            value = value-1;
            console.log("value::: " + value)
            displayCategoryQuestions(value);
        }
        function moveCategory(value) {
            //var check = validation();
            //if (check) {


               // displayCategoryQuestions(value);
           // }

        }
       

        function fetchRecords() {
            // Fetch all the records from backend;
            // patchvalue
        }
        function validation() {
             var getcount = allQuestions[counter].Count;
            var fieldCount = $("#form-questn").serializeArray().length;
            if (fieldCount != getcount) {
                console.log('fieldCount', fieldCount);
                 console.log('getcount',getcount);
                getcount =getcount- fieldCount  ;
                console.log(getcount);
                toastr.error('kindly, select all the entries <br/>  '+ getcount +'  fill(s) left!!!', "Validation");
                return false;
            }
            return true;
        }
       
        function submitForm()
        {
            // first check ur local db
            // if exist patch value to the db
            // else not check online;
            // and save into local data
            // if there's nothing online
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;
            
             var  checker =validation()
           
            //
            if (checker) {
                var formObject = $("#form-questn").serializeArray();
                var CategoryId = allQuestions[counter].QuestionCategoryId;
                var formData = { QuestionCategoryId: CategoryId, Questionlists: formObject, IsCompleted:presentValue == arrayLength };
                var url = '@Url.Action("SaveQuestionByCategoryAsync", "AssessmentPortal")';
                var saveData = $.ajax({
                    type: 'POST',
                    url: url,
                    data: JSON.stringify(formData),
                    contentType: 'application/json; charset=utf-8',
                    dataType: "json",
                    success: function (resultData) {
                        if (presentValue < arrayLength)
                            toastr.success("Move to the next Question Category", "Notification");
                        else {
                            toastr.success("Your assessment has been submitted", "Notification");
                             console.log("resultData", resultData)
                            console.log("resultData.scheduleId", resultData.scheduleId)

                            CorrectivePlan(resultData.scheduleId);
                        }


                         if (presentValue < arrayLength) {
                displayCategoryQuestions(presentValue)
            }
                    }
                });
            }
//            localStorage.setItem("","");
        }
               function CorrectivePlan(id) {
                   var url = '@Url.Action("CorrectivePlan", "AssessmentPortal")?AssSchId=' + id + '';
                   console.log("Url", url);
    window.location.href = url;
}

    </script>
    @Scripts.Render("~/bundles/bootstrap")
    <script src="~/Content/vendors/base/vendor.bundle.base.js"></script>
    <script src="~/Scripts/js/toastr.js"></script>
    <script src="~/Scripts/js/off-canvas.js"></script>
    <script src="~/Scripts/js/hoverable-collapse.js"></script>
    <script src="~/Scripts/js/template.js"></script>
    <script src="~/Scripts/js/loader.js"></script>

    @Scripts.Render("~/bundles/jquery-ui")

    <script src="~/Scripts/js/file-upload.js"></script>

</body>
</html>

<!-- JQUERY FOR NEXT AND PREV FUNCTIONALITY -->





